package net.lecnam.info.remotemap;

import java.util.concurrent.BlockingQueue;
import java.util.logging.Logger;
import net.lecnam.info.remotemap.Answer.*;
import net.lecnam.info.remotemap.Request.*;

class RemoteMap<K, V> extends AbstractMap<K, V> {

	BlockingQueue<Answer<V>> in;
	BlockingQueue<Request<K, V>> out;

	static final Logger logger = Logger.getLogger("client");

	RemoteMap(BlockingQueue<Answer<V>> in, BlockingQueue<Request<K, V>> out) {
		this.in = in;
		this.out = out;
	}

	@Override
	public int size() {
		throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
	}

	@Override
	public boolean isEmpty() {
		throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
	}

	@Override
	public boolean containsKey(Object key) {
		throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
	}

	@Override
	public boolean containsValue(Object value) {
		throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
	}

	@Override
	public V get(Object key) {
		try {
			Request<K, V> request = new Get<>((K) key);
			out.put(request);
			Answer<V> answer = in.take();
			logger.info("Answer: " + answer);
			switch (answer) {
				case Value(var value) -> {
					return value;
				}
				default -> {
					throw new Error("Invalid answer");
				}
			}
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	@Override
	public V put(K key, V value) {
		try {
			Request<K, V> request = new Put<>(key, value);
			out.put(request);
			Answer<V> answer = in.take();
			logger.info("Answer: " + answer);
			switch (answer) {
				case OldValue(var old) -> {
					return old;
				}
				default -> {
					throw new Error("Invalid answer");
				}
			}
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	@Override
	public V remove(Object key) {
		throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
	}

	public void stop() {
		try {
			Request<K, V> request = new Stop<>();
			out.put(request);
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

}
